

                                   ~0E
                 THE EVOLUTION OF THE 50/50 SEX RATIO:
    A COMPUTER TUTORIAL AND SIMULATION OF AN EVOLUTIONARY STABLE STRATEGY


                        Michael E. Mills, Ph.D.
                         Psychology Department
                      Loyola Marymount University
                         Los Angeles, CA 90045


    Copyright 1991 Michael E. Mills


    Press the "Pg Dn" (page down) key to continue.






      ~1F

    We often hear the phrase that evolution occurs for the "good  of
    the  species."   However,  as  we  will see in this tutorial and
    computer simulation, this is a "specious" argument.  (sorry... )

    Since goal in the "game of life" is leave as many  offspring  as
    possible, if evolution occurred for the "good of the species" we
    would expect various species to  compete  with  one  another  to
    maximize  their relative numbers.  The species with the greatest
    population would "win."

    We would also expect that individual members of a species  would
    sacrifice  their  own  personal  reproductive  interests for the
    greater  reproductive  interests  of  the  species.   Once   the
    population of the species had reached the "carrying capacity" of
    the environment (e.g., just enough  food  available  to  support
    everyone),   we   would   expect   this   speciesto  reduce  its
    reproductive output. Note that this goal is in  direct  conflict
    to  the  interest  of individuals who wish to maximize their own
    reproductive output vis-a-vis the reproductive output  of  other
    individuals.    So  we  have a situation wherein the goal of the
    "good of the individual" is in direct conflict with the goal  of
    the  "good  of  the  species."   Which wins out?  Do individuals
    behave cooperatively for the good of the  species,  or  do  they
    behave selfishly and continue to reproduce to maximize their own
    personal  reproductive  output  (even  at  the  peril   of   the
    reproductive  output,  and  possibly even the survival, of their
    own species)?

    Before we answer that  question,  let's  also  look  at  another
    phenomenon  wherein  the  interests of the species conflict with
    the interests of the individual: the sex  ratio.     Before  the
    carrying capacity of the environment is reached, we would expect
    that a  specieswould  attempt  to  increase  its  population  as
    quickly  as  possible.   In  that  way,  it  will win out in the
    competition with other species.  Since the number of females  is
    the  limiting  factor  in determining the reproductive output of
    the species, to maximize its reproductive output we would expect
    species  to evolve a sex ratio of about 95% females to 5% males.
    Compared to a 50/50 sex  ratio,  this  95/5  ratio  will  almost
    double the reproductive output of the species.

    But why does the 95/5 sex ratio conflict with  the  reproductive
    interests  of  an  individual?    Wouldn't  it  also  be  in the
    interests of an individual to have  mostly  daughters,  in  that
    females usually have no problem finding males who are willing to
    copulate with them?  Also, males have a higher  mortality  rate,
    and  a  few males will have difficulty finding any female who is
    willing to  copulate  with  them.  Daughters,  it  seems,  would
    represent a more of a "sure bet" -- less of a gamble than sons.

    However, in a population composed of 95% females, having  a  son
    would  definitely  be  in  individual's  reproductive interests.
    Unlike a female, a male's reproductive output is not limited  to
    his  own  biology.   Rather, it is limited only by the number of
    different females to which he can  get  sexual  access.    Since
    there  are  95  females for every 5 males in this population,  a
    son could have  many  times  the  number  of  offspring  that  a
    daughter could have.

    If the sex ratio pendulum should swing far to the other side, so
    that  the sex ratio is now 95% males and 5% females, you can see
    that  having  a  daughter  would  now  be   in   your   personal
    reproductive  interests.  There  will  be  a lot of sons who are
    completely "reproductively disenfranchized" -- unable to find  a
    female.

    So, what is the best strategy to follow if you wish to  maximize
    your  own  personal reproductive interests?   What proportion of
    sons vs.  daughters would you like to have?  It turns  out  that
    the overall best strategy is to have about 50% daughters and 50%
    sons.  This is called an "evolutionary stable strategy," or ESS.
    An ESS is a strategy that in the long run, on average, cannot be
    bettered by an alternate strategy.

    Thus, we have a dilemma:   the  reproductive  interests  of  the
    specie  (95/5  sex  ratio)  is  at  odds  with  the reproductive
    interests of the individual (50/50 sex ratio). As an individual,
    will you attempt to work for the "good of the species" by having
    95% daughters and 5% sons, or will you attempt to maximize  your
    own personal reproductive output by having 50% daughters and 50%
    sons?

    It appears that selection virtually always occurs at  the  level
    of  the  individual,  not  the  species.  Individuals often will
    continue to have offspring even after the carrying  capacity  of
    the   environment   is  exceeded,  often  resulting  in  a  mass
    starvation.   The sex ratio for the vast majority of species  is
    about 50/50.

    Right now, let's create our own miniature universe:  a  computer
    simulation.  We will set up the rules, and then see what evolves
    in our computer simulated little universe.   We  will  see  what
    happens  to a hypothetical population that initially consists of
    80% males and 20% females.  Will the resulting sex ratio be  95%
    females  and  5%  males,  or will it work out to an evolutionary
    equilibrium point of the 50/50 sex ratio?  Let's see.

    Here are the rules:

    1.  Males and females are free to move about in  any  direction.
         Males  and  females  not  of  reproductive  age  are  grey.
         Reproductive males are blue, reproductive females are red.

    2.  When a reproductive male and reproductive  female  encounter
         one  another, they spend a second or two courting.  If they
         like each other (there is an 80% chance  that  they  will),
         they mate.  Mating is indicated by the pair blinking on the
         screen and the sound of a beep on the computer speaker.

    3.  For each mated pair, there is a 70%  chance that  they  will
         have  one  offspring,  a 20% chance that they will have two
         offspring, and a 10%  chance  that  they  will  have  three
         offspring.  Offspring are placed as close to the parents as
         possible, in the first available empty space.  Offspring do
         not  become  reproductive for a few seconds, and until they
         become reproductive they are grey.

    4.  After mating, the pair splits apart and goes off looking for
         another  mating  opportunity.   That  is,  they are "serial
         monogamists."  However, after mating, there is a few second
         delay before they are allowed to mate again.

    5. Individuals die after about 10 seconds of life.  Their  death
         is indicated by their disappearance from the screen.

    6. We will start off with 200 males and 50 females.

         Press the ESC key to begin.

