 //Begin CARULE.HPP
//-----------WAVE parameter names-------------------
#define PAST_C_I owner->wave_past_row[c].intensity
#define L_I owner->wave_source_row[l].intensity
#define C_I owner->wave_source_row[c].intensity
#define R_I owner->wave_source_row[r].intensity
#define NEW_C_I	owner->wave_target_row[c].intensity
#define PAST_C_V owner->wave_past_row[c].velocity
#define L_V owner->wave_source_row[l].velocity
#define C_V owner->wave_source_row[c].velocity
#define R_V owner->wave_source_row[r].velocity
#define NEW_C_V owner->wave_target_row[c].velocity
#define MAX_INTENSITY owner->_max_intensity.Val()
#define MAX_VELOCITY owner->_max_velocity.Val()
#define DT owner->_dt.Val()
#define DX owner->_dx.Val()
#define LAMBDA owner->_wavespeed_2_times_dt_2_over_dx_2
#define NEW_WAVE_ACTIVATOR -PAST_C_I+2.0*(1.0-LAMBDA)*C_I+LAMBDA*(L_I+R_I)
#define NEW_WAVE_INHIBITOR -PAST_C_V+2.0*(1.0-LAMBDA)*C_V+LAMBDA*(L_V+R_V)
//--------------OSCILLATOR parameter names-------------
#define MASS owner->_mass.Val()
#define FRICTION owner->_friction_multiplier.Val()
#define SPRING owner->_spring_multiplier.Val()
#define AMPLITUDE owner->_driver_multiplier.Val()
#define FREQUENCY owner->frequency_factor
#define PHASE owner->_phase
#define TIME owner->time
//-------------SHELL parameter names--------------
#define ACTIVATOR owner->wave_source_row[c].intensity
#define INHIBITOR owner->wave_source_row[c].velocity
#define NEW_ACTIVATOR owner->wave_target_row[c].intensity
#define NEW_INHIBITOR owner->wave_target_row[c].velocity
#define DIFFUSION_RATE_ACTIVATOR 2.0 //MASS
#define DIFFUSION_RATE_INHIBITOR 0.5 //SPRING
#define DECAY_RATE_ACTIVATOR 0.1 //AMPLITUDE
#define DECAY_RATE_INHIBITOR 0.2 //FRICTION
#define ACTIVATOR_PRODUCTION 2.0
#define INHIBITOR_PRODUCTION 1.1
#define ACTIVATOR_AVG (DIFFUSION_RATE_ACTIVATOR*L_I+C_I+DIFFUSION_RATE_ACTIVATOR*R_I)/(1+2.0*DIFFUSION_RATE_ACTIVATOR);
#define INHIBITOR_AVG (DIFFUSION_RATE_INHIBITOR*L_V+C_V+DIFFUSION_RATE_INHIBITOR*R_V)/(1+2.0*DIFFUSION_RATE_INHIBITOR);
#define MAX_ACTIVATOR MAX_INTENSITY
#define MAX_INHIBITOR MAX_VELOCITY
#define CELL_STRENGTH owner->wave_source_row[c]._cell_param[0]

#ifndef __FLAT__ //16 bit DLL entry
	#pragma argsused
	int CALLBACK LibMain(HANDLE hInstance, WORD wDataSeg, WORD wHeapSize,
		LPSTR lpszCmdLine)
	{
		if (wHeapSize > 0)
			UnlockData(0);
		return 1;
	}
//	#pragma argsused
 //	int CALLBACK _export WEP (int nParameter)
//	{
//		return 1;
//	}
#endif //end 16 bit DLL entry

#ifdef __FLAT__ //begin 32 bit DLL entry
	#ifdef __BORLANDC__ //Borland
		int WINAPI DllEntryPoint(HINSTANCE hInst, DWORD reason, LPVOID)
	#else // Visual C++
		int WINAPI DllMain(HINSTANCE hInst, DWORD reason, LPVOID)
	#endif //end Borland/VCC switch
		{
			return 1;
		}
#endif //end 32 bit DLL entry

//End CARULE.HPP

