#ifndef TYPES_H
#define TYPES_H


//============WINDOWS INCLUDE=======
/* We want to do this here so that the same "STRICT" version
of windows.h gets used throughout.  Don't allow any #include windows.h
anywhere else.  Always do #include types.h instead. */
#define STRICT
#include <windows.h>
#include <windowsx.h>
#pragma warning (disable : 4068)


#ifndef __BORLANDC__
#define __FLAT__ //Means 32 bit build, which is what VCC always does
#endif //__BORLANDC__

//=================VARIABLE TYPES=====
/* double gives you better accuracy, float gives you better speed.*/
//#define DOUBLE
#ifdef DOUBLE
	typedef double Real;
#else //not DOUBLE means float
	typedef float Real;
#endif //DOUBLE

//================CONSTANTS=====
#define PI (Real)3.141592653
/*If time grows without bound, you might get a floating point overflow
during a long run.  But you don't want to wrap the time at 2*PI in case
you frequency is like 0.1, becuase that needs 10*PI to go through a
full cycle*/
#define TIMEWRAP (Real)100000.0*PI
#define SMALL_REAL 0.0001 //for avoiding division by zero.
#define BIG_REAL 100000.0 //For default maximum of TweakParam

//=================ASSERT============
//#define NDEBUG //Comment this in to turn off assert checking.
#include <assert.h>

//================FUNCTION TYPES=====
class CA; //Forward declaration for the FPCELLUPDATE typedef.

#ifdef __BORLANDC__ //Only use this for 16 bit
	#define DllExport void CALLBACK _export
//	#define DllImport void CALLBACK
	typedef DllExport (*FPCELLUPDATE)(CA FAR *, int, int, int);
	//Used to be typedef void CALLBACK _export (*FPCELLUPDATE)(CA FAR *, int, int, int);
#else //Microsoft Visual C++ case
	#define DllExport __declspec( dllexport ) void
//	#define DllImport __declspec( dllimport ) void
	typedef DllExport (*FPCELLUPDATE)(CA FAR *, int, int, int);
#endif //MSVCC


#endif //TYPES_H
